diff --git a/strongswan-5.2.0/src/libstrongswan/crypto/crypto_factory.h b/strongswan-5.2.0/src/libstrongswan/crypto/crypto_factory.h
index 7865bcb..74aba4e 100644
--- a/strongswan-5.2.0/src/libstrongswan/crypto/crypto_factory.h
+++ b/strongswan-5.2.0/src/libstrongswan/crypto/crypto_factory.h
@@ -12,6 +12,28 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  */
+ 
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 /**
  * @defgroup crypto_factory crypto_factory
@@ -33,6 +55,7 @@ typedef struct crypto_factory_t crypto_factory_t;
 #include <crypto/rngs/rng.h>
 #include <crypto/nonce_gen.h>
 #include <crypto/diffie_hellman.h>
+#include <crypto/key_transformer.h>
 #include <crypto/transform.h>
 
 #define CRYPTO_MAX_ALG_LINE          120   /* characters */
@@ -80,6 +103,11 @@ typedef nonce_gen_t* (*nonce_gen_constructor_t)();
  */
 typedef diffie_hellman_t* (*dh_constructor_t)(diffie_hellman_group_t group, ...);
 
+/**
+ * Constructor function for key transformer
+ */
+typedef key_transformer_t* (*key_tfmer_constructor_t)(key_transform_alorithm_t algo);
+
 /**
  * Handles crypto modules and creates instances.
  */
@@ -158,6 +186,15 @@ struct crypto_factory_t {
 	diffie_hellman_t* (*create_dh)(crypto_factory_t *this,
 								   diffie_hellman_group_t group, ...);
 
+	/**
+	 * Create a key transformer instance.
+	 *
+	 * @param algo 			key transform algorithm to use
+	 * @return 				key_transformer_t instance, NULL if not supported
+	 */
+	key_transformer_t* (*create_key_transformer)(crypto_factory_t *this, 
+											key_transform_alorithm_t algo);
+
 	/**
 	 * Register a crypter constructor.
 	 *
@@ -302,6 +339,27 @@ struct crypto_factory_t {
 	 */
 	void (*remove_dh)(crypto_factory_t *this, dh_constructor_t create);
 
+	/**
+	 * Register key transformer constructor.
+	 *
+	 * @param algo			algorithm to constructor
+	 * @param plugin_name	plugin that registered this algorithm
+	 * @param create		constructor function for that algorithm
+	 * @return				TRUE if registered, FALSE if test vector failed
+	 */
+	bool (*add_key_transformer)(crypto_factory_t *this,
+								key_transform_alorithm_t algo, 
+								const char *plugin_name,
+								key_tfmer_constructor_t create);
+
+	/**
+	 * Unregister key transformer constructor.
+	 *
+	 * @param create		constructor function to unregiste
+	 */
+	void (*remove_key_transformer)(crypto_factory_t *this,
+								key_tfmer_constructor_t create);
+
 	/**
 	 * Create an enumerator over all registered crypter algorithms.
 	 *
@@ -358,6 +416,13 @@ struct crypto_factory_t {
 	 */
 	enumerator_t* (*create_nonce_gen_enumerator)(crypto_factory_t *this);
 
+	/**
+	 * Create an enumerator over all registered key transformers.
+	 *
+	 * @return				enumerator over key_transform_alorithm_t, plugin
+	 */
+	enumerator_t* (*create_key_transformer_enumerator)(crypto_factory_t *this);
+
 	/**
 	 * Add a test vector to the crypto factory.
 	 *
diff --git a/strongswan-5.2.0/src/libstrongswan/crypto/diffie_hellman.c b/strongswan-5.2.0/src/libstrongswan/crypto/diffie_hellman.c
index 5c1d08d..79648d5 100644
--- a/strongswan-5.2.0/src/libstrongswan/crypto/diffie_hellman.c
+++ b/strongswan-5.2.0/src/libstrongswan/crypto/diffie_hellman.c
@@ -13,7 +13,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include "diffie_hellman.h"
 
@@ -42,7 +64,9 @@ ENUM_NEXT(diffie_hellman_group_names, MODP_1024_160, ECP_512_BP, ECP_521_BIT,
 	"ECP_256_BP",
 	"ECP_384_BP",
 	"ECP_512_BP");
-ENUM_NEXT(diffie_hellman_group_names, MODP_NULL, MODP_CUSTOM, ECP_512_BP,
+ENUM_NEXT(diffie_hellman_group_names, ECP_256_BIGN, ECP_256_BIGN, ECP_512_BP,
+	"ECP_256_BIGN");
+ENUM_NEXT(diffie_hellman_group_names, MODP_NULL, MODP_CUSTOM, ECP_256_BIGN,
 	"MODP_NULL",
 	"MODP_CUSTOM");
 ENUM_NEXT(diffie_hellman_group_names, NTRU_112_BIT, NTRU_256_BIT, MODP_CUSTOM,
@@ -475,6 +499,7 @@ bool diffie_hellman_group_is_ec(diffie_hellman_group_t group)
 		case ECP_256_BP:
 		case ECP_384_BP:
 		case ECP_512_BP:
+		case ECP_256_BIGN:
 			return TRUE;
 		default:
 			return FALSE;
diff --git a/strongswan-5.2.0/src/libstrongswan/crypto/diffie_hellman.h b/strongswan-5.2.0/src/libstrongswan/crypto/diffie_hellman.h
index 00d7003..84a410e 100644
--- a/strongswan-5.2.0/src/libstrongswan/crypto/diffie_hellman.h
+++ b/strongswan-5.2.0/src/libstrongswan/crypto/diffie_hellman.h
@@ -13,7 +13,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 /**
  * @defgroup diffie_hellman diffie_hellman
@@ -60,6 +82,7 @@ enum diffie_hellman_group_t {
 	ECP_256_BP    = 28,
 	ECP_384_BP    = 29,
 	ECP_512_BP    = 30,
+	ECP_256_BIGN  = 31,
 	/** insecure NULL diffie hellman group for testing, in PRIVATE USE */
 	MODP_NULL = 1024,
 	/** MODP group with custom generator/prime */
@@ -80,7 +103,7 @@ extern enum_name_t *diffie_hellman_group_names;
  * Implementation of the Diffie-Hellman algorithm, as in RFC2631.
  */
 struct diffie_hellman_t {
-
+ 
 	/**
 	 * Returns the shared secret of this diffie hellman exchange.
 	 *
diff --git a/strongswan-5.2.0/src/libstrongswan/crypto/hashers/hasher.c b/strongswan-5.2.0/src/libstrongswan/crypto/hashers/hasher.c
index 13cbb5a..98628e7 100644
--- a/strongswan-5.2.0/src/libstrongswan/crypto/hashers/hasher.c
+++ b/strongswan-5.2.0/src/libstrongswan/crypto/hashers/hasher.c
@@ -14,12 +14,34 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  */
+ 
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include "hasher.h"
 
 #include <asn1/oid.h>
 
-ENUM(hash_algorithm_names, HASH_UNKNOWN, HASH_SHA512,
+ENUM(hash_algorithm_names, HASH_UNKNOWN, BELT_HMAC,
 	"HASH_UNKNOWN",
 	"HASH_MD2",
 	"HASH_MD4",
@@ -28,10 +50,15 @@ ENUM(hash_algorithm_names, HASH_UNKNOWN, HASH_SHA512,
 	"HASH_SHA224",
 	"HASH_SHA256",
 	"HASH_SHA384",
-	"HASH_SHA512"
+	"HASH_SHA512",
+	"BELT_HASH",
+	"GOST_MAC",
+	"BELT_MAC",
+	"BELT_HMAC"
+
 );
 
-ENUM(hash_algorithm_short_names, HASH_UNKNOWN, HASH_SHA512,
+ENUM(hash_algorithm_short_names, HASH_UNKNOWN, BELT_HMAC,
 	"unknown",
 	"md2",
 	"md4",
@@ -40,8 +67,12 @@ ENUM(hash_algorithm_short_names, HASH_UNKNOWN, HASH_SHA512,
 	"sha224",
 	"sha256",
 	"sha384",
-	"sha512"
-);
+	"sha512",
+	"belt_hash",
+	"gost_mac",
+	"belt_mac",
+	"belt_hmac"
+);	
 
 /*
  * Described in header.
@@ -71,6 +102,14 @@ hash_algorithm_t hasher_algorithm_from_oid(int oid)
 		case OID_SHA512:
 		case OID_SHA512_WITH_RSA:
 			return HASH_SHA512;
+		case OID_BELT_HASH:
+			return BELT_HASH;
+		case OID_GOST_MAC:
+			return GOST_MAC;
+		case OID_BELT_MAC:
+			return BELT_MAC;
+		case OID_BELT_HMAC:
+			return BELT_HMAC;
 		default:
 			return HASH_UNKNOWN;
 	}
@@ -101,6 +140,8 @@ hash_algorithm_t hasher_algorithm_from_prf(pseudo_random_function_t alg)
 		case PRF_FIPS_DES:
 		case PRF_CAMELLIA128_XCBC:
 		case PRF_UNDEFINED:
+		case PRF_BRNG_CTR_HBELT:
+		case PRF_BRNG_HMAC_HBELT:
 			break;
 	}
 	return HASH_UNKNOWN;
@@ -142,6 +183,11 @@ hash_algorithm_t hasher_algorithm_from_integrity(integrity_algorithm_t alg,
 			case AUTH_HMAC_SHA2_512_512:
 				*length = 64;
 				break;
+			case AUTH_BELT_HASH:
+			case AUTH_GOST_MAC:
+			case AUTH_BELT_MAC:
+			case AUTH_BELT_HMAC:
+				*length = 32;
 			default:
 				break;
 		}
@@ -166,6 +212,11 @@ hash_algorithm_t hasher_algorithm_from_integrity(integrity_algorithm_t alg,
 		case AUTH_HMAC_SHA2_512_256:
 		case AUTH_HMAC_SHA2_512_512:
 			return HASH_SHA512;
+		case AUTH_GOST_MAC:
+		case AUTH_BELT_MAC:
+		case AUTH_BELT_HMAC:
+		case AUTH_BELT_HASH:
+			return BELT_HASH;
 		case AUTH_AES_CMAC_96:
 		case AUTH_AES_128_GMAC:
 		case AUTH_AES_192_GMAC:
@@ -237,6 +288,14 @@ integrity_algorithm_t hasher_algorithm_to_integrity(hash_algorithm_t alg,
 					return AUTH_HMAC_SHA2_512_512;
 			}
 			break;
+		case BELT_HASH:
+			return AUTH_BELT_HASH;
+		case GOST_MAC:
+			return AUTH_GOST_MAC;
+		case BELT_MAC:
+			return AUTH_BELT_MAC;	
+		case BELT_HMAC:
+			return AUTH_BELT_HMAC;	
 		case HASH_MD2:
 		case HASH_MD4:
 		case HASH_SHA224:
@@ -276,6 +335,18 @@ int hasher_algorithm_to_oid(hash_algorithm_t alg)
 		case HASH_SHA512:
 			oid = OID_SHA512;
 			break;
+		case BELT_HASH:
+			oid = OID_BELT_HASH;
+			break;
+		case GOST_MAC:
+			oid = OID_GOST_MAC;
+			break;
+		case BELT_MAC:
+			oid = OID_BELT_MAC;
+			break;
+		case BELT_HMAC:
+			oid = OID_BELT_HMAC;
+			break;
 		default:
 			oid = OID_UNKNOWN;
 	}
@@ -323,8 +394,16 @@ int hasher_signature_algorithm_to_oid(hash_algorithm_t alg, key_type_t key)
 				default:
 					return OID_UNKNOWN;
 			}
+		case KEY_BIGN:
+			switch (alg)
+			{
+				case BELT_HASH:
+					return OID_HASH_BELT;
+				case HASH_UNKNOWN:									
+				default:
+					return OID_UNKNOWN;
+			}
 		default:
 			return OID_UNKNOWN;
 	}
-}
-
+}
\ No newline at end of file
diff --git a/strongswan-5.2.0/src/libstrongswan/crypto/hashers/hasher.h b/strongswan-5.2.0/src/libstrongswan/crypto/hashers/hasher.h
index 37ef0b6..b896898 100644
--- a/strongswan-5.2.0/src/libstrongswan/crypto/hashers/hasher.h
+++ b/strongswan-5.2.0/src/libstrongswan/crypto/hashers/hasher.h
@@ -13,7 +13,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 /**
  * @defgroup hasher hasher
@@ -44,7 +66,12 @@ enum hash_algorithm_t {
 	HASH_SHA224			= 5,
 	HASH_SHA256 		= 6,
 	HASH_SHA384 		= 7,
-	HASH_SHA512 		= 8
+	HASH_SHA512 		= 8,
+	BELT_HASH			= 9,
+	GOST_MAC			= 10,
+	BELT_MAC			= 11,
+	BELT_HMAC			= 12
+
 };
 
 #define HASH_SIZE_MD2		16
@@ -55,6 +82,11 @@ enum hash_algorithm_t {
 #define HASH_SIZE_SHA256	32
 #define HASH_SIZE_SHA384	48
 #define HASH_SIZE_SHA512	64
+#define HASH_SIZE_BELT		32
+#define HASH_SIZE_GOST_MAC	 4
+#define HASH_SIZE_BELT_MAC	 8
+#define HASH_SIZE_BELT_HMAC	 32
+
 
 /**
  * enum names for hash_algorithm_t.
diff --git a/strongswan-5.2.0/src/libstrongswan/crypto/key_transformer.c b/strongswan-5.2.0/src/libstrongswan/crypto/key_transformer.c
new file mode 100644
index 0000000..c14ee88
--- /dev/null
+++ b/strongswan-5.2.0/src/libstrongswan/crypto/key_transformer.c
@@ -0,0 +1,28 @@
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
+
+#include "key_transformer.h"
+
+ENUM(key_transform_algorithm_names, KEYTFM_UNDEFINED, BELT_KEYREP_TRANSFORM,
+	"KEY_TRANSFORM_UNDEFINED",
+	"BELT_KEYREP_TRANSFORM",
+);
\ No newline at end of file
diff --git a/strongswan-5.2.0/src/libstrongswan/crypto/key_transformer.h b/strongswan-5.2.0/src/libstrongswan/crypto/key_transformer.h
new file mode 100644
index 0000000..5c42041
--- /dev/null
+++ b/strongswan-5.2.0/src/libstrongswan/crypto/key_transformer.h
@@ -0,0 +1,77 @@
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
+
+/**
+ * @defgroup key_transformer key_transformer
+ * @{ @ingroup crypto
+ */
+
+#ifndef KEY_TRANSFORMER_H_
+#define KEY_TRANSFORMER_H_
+
+typedef enum key_transform_alorithm_t key_transform_alorithm_t;
+typedef enum key_transform_args_t key_transform_args_t;
+typedef struct key_transformer_t key_transformer_t;
+
+#include <library.h>
+
+/**
+ *	Key transform algorithm
+ */
+enum key_transform_alorithm_t {
+
+	KEYTFM_UNDEFINED = 0,
+	
+	/** KeyRep algorithm from STB 34.101.31 */
+	BELT_KEYREP_TRANSFORM = 1,
+};
+
+/**
+ * enum strings for key_transform_alorithm_t.
+ */
+extern enum_name_t *key_transform_algorithm_names;
+
+/**
+ * Key transform interface.
+ */
+struct key_transformer_t {
+
+	/**
+	 * Transform key of proveded level into another key 
+	 * of level + 1 associated with proveded header.
+	 *
+	 * @param in 			a key to transform
+	 * @param out 			transformed key
+	 * @param in_level		level of the input key
+	 * @param out_header	header associated with produced key
+	 * @return				TRUE on successful transformation, FALSE otherwise
+	 */
+	bool (*transform)(key_transformer_t *this, chunk_t in, chunk_t out, 
+									chunk_t in_level, chunk_t out_header);
+
+	/**
+	 * Destructor.
+	 */
+	void (*destroy)(key_transformer_t *this);
+};
+
+#endif /** KEY_TRANSFORMER_H_ @}*/
diff --git a/strongswan-5.2.0/src/libstrongswan/crypto/prfs/prf.c b/strongswan-5.2.0/src/libstrongswan/crypto/prfs/prf.c
index 12e13ef..01d9be7 100644
--- a/strongswan-5.2.0/src/libstrongswan/crypto/prfs/prf.c
+++ b/strongswan-5.2.0/src/libstrongswan/crypto/prfs/prf.c
@@ -12,7 +12,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include "prf.h"
 
@@ -22,7 +44,7 @@ ENUM_BEGIN(pseudo_random_function_names, PRF_UNDEFINED, PRF_CAMELLIA128_XCBC,
 	"PRF_FIPS_DES",
 	"PRF_KEYED_SHA1",
 	"PRF_CAMELLIA128_XCBC");
-ENUM_NEXT(pseudo_random_function_names, PRF_HMAC_MD5, PRF_AES128_CMAC, PRF_CAMELLIA128_XCBC,
+ENUM_NEXT(pseudo_random_function_names, PRF_HMAC_MD5, PRF_BRNG_HMAC_HBELT, PRF_CAMELLIA128_XCBC,
 	"PRF_HMAC_MD5",
 	"PRF_HMAC_SHA1",
 	"PRF_HMAC_TIGER",
@@ -30,6 +52,8 @@ ENUM_NEXT(pseudo_random_function_names, PRF_HMAC_MD5, PRF_AES128_CMAC, PRF_CAMEL
 	"PRF_HMAC_SHA2_256",
 	"PRF_HMAC_SHA2_384",
 	"PRF_HMAC_SHA2_512",
-	"PRF_AES128_CMAC");
-ENUM_END(pseudo_random_function_names, PRF_AES128_CMAC);
+	"PRF_AES128_CMAC",
+	"PRF_BRNG_CTR_HBELT",
+	"PRF_BRNG_HMAC_HBELT");
+ENUM_END(pseudo_random_function_names, PRF_BRNG_HMAC_HBELT);
 
diff --git a/strongswan-5.2.0/src/libstrongswan/crypto/prfs/prf.h b/strongswan-5.2.0/src/libstrongswan/crypto/prfs/prf.h
index 46e23b2..2b87a15 100644
--- a/strongswan-5.2.0/src/libstrongswan/crypto/prfs/prf.h
+++ b/strongswan-5.2.0/src/libstrongswan/crypto/prfs/prf.h
@@ -12,7 +12,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 /**
  * @defgroup prf prf
@@ -50,6 +72,10 @@ enum pseudo_random_function_t {
 	PRF_HMAC_SHA2_512 = 7,
 	/** RFC4615 */
 	PRF_AES128_CMAC = 8,
+	/** PRFBRNG_CTR */
+	PRF_BRNG_CTR_HBELT = 9,
+	/** PRFBRNG_HMAC */
+	PRF_BRNG_HMAC_HBELT = 10,
 	/** FIPS 186-2-change1 */
 	PRF_FIPS_SHA1_160 = 1025,
 	/** FIPS 186-2-change1, uses fixed output size of 160bit */
diff --git a/strongswan-5.2.0/src/libstrongswan/crypto/signers/signer.c b/strongswan-5.2.0/src/libstrongswan/crypto/signers/signer.c
index 522b4e2..b720938 100644
--- a/strongswan-5.2.0/src/libstrongswan/crypto/signers/signer.c
+++ b/strongswan-5.2.0/src/libstrongswan/crypto/signers/signer.c
@@ -12,7 +12,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include "signer.h"
 
@@ -24,7 +46,7 @@ ENUM_BEGIN(integrity_algorithm_names, AUTH_UNDEFINED, AUTH_CAMELLIA_XCBC_96,
 	"HMAC_SHA2_384_384",
 	"HMAC_SHA2_512_512",
 	"CAMELLIA_XCBC_96");
-ENUM_NEXT(integrity_algorithm_names, AUTH_HMAC_MD5_96, AUTH_HMAC_SHA2_512_256, AUTH_CAMELLIA_XCBC_96,
+ENUM_NEXT(integrity_algorithm_names, AUTH_HMAC_MD5_96, AUTH_BELT_HASH, AUTH_CAMELLIA_XCBC_96,
 	"HMAC_MD5_96",
 	"HMAC_SHA1_96",
 	"DES_MAC",
@@ -38,6 +60,10 @@ ENUM_NEXT(integrity_algorithm_names, AUTH_HMAC_MD5_96, AUTH_HMAC_SHA2_512_256, A
 	"AES_256_GMAC",
 	"HMAC_SHA2_256_128",
 	"HMAC_SHA2_384_192",
-	"HMAC_SHA2_512_256");
-ENUM_END(integrity_algorithm_names, AUTH_HMAC_SHA2_512_256);
+	"HMAC_SHA2_512_256",
+	"GOST_MAC",
+	"BELT_MAC",
+	"BELT_HMAC",
+	"BELT_HASH");
+ENUM_END(integrity_algorithm_names, AUTH_BELT_HASH);
 
diff --git a/strongswan-5.2.0/src/libstrongswan/crypto/signers/signer.h b/strongswan-5.2.0/src/libstrongswan/crypto/signers/signer.h
index e0cf7eb..9a5d10b 100644
--- a/strongswan-5.2.0/src/libstrongswan/crypto/signers/signer.h
+++ b/strongswan-5.2.0/src/libstrongswan/crypto/signers/signer.h
@@ -12,7 +12,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 /**
  * @defgroup signer signer
@@ -62,6 +84,14 @@ enum integrity_algorithm_t {
 	AUTH_HMAC_SHA2_384_192 = 13,
 	/** RFC4868 */
 	AUTH_HMAC_SHA2_512_256 = 14,
+	
+	AUTH_GOST_MAC	= 15,
+	
+	AUTH_BELT_MAC	= 16,
+
+	AUTH_BELT_HMAC	= 17,
+	
+	AUTH_BELT_HASH	= 18,
 	/** private use */
 	AUTH_HMAC_SHA1_128 = 1025,
 	/** SHA256 96 bit truncation variant, supported by Linux kernels */
@@ -154,3 +184,4 @@ struct signer_t {
 };
 
 #endif /** SIGNER_H_ @}*/
+
diff --git a/strongswan-5.2.0/src/libstrongswan/crypto/transform.c b/strongswan-5.2.0/src/libstrongswan/crypto/transform.c
index 5625297..63ab5db 100644
--- a/strongswan-5.2.0/src/libstrongswan/crypto/transform.c
+++ b/strongswan-5.2.0/src/libstrongswan/crypto/transform.c
@@ -11,7 +11,29 @@
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
- */
+ */ 
+
+/*
+ * Copyright (C) 2017 NTC CONTACT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */ 
 
 #include <crypto/transform.h>
 
@@ -21,16 +43,17 @@ ENUM_BEGIN(transform_type_names, UNDEFINED_TRANSFORM_TYPE, COMPRESSION_ALGORITHM
 	"RANDOM_NUMBER_GENERATOR",
 	"AEAD_ALGORITHM",
 	"COMPRESSION_ALGORITHM");
-ENUM_NEXT(transform_type_names, ENCRYPTION_ALGORITHM, EXTENDED_SEQUENCE_NUMBERS, COMPRESSION_ALGORITHM,
+ENUM_NEXT(transform_type_names, ENCRYPTION_ALGORITHM, KEY_TRANSFORM_ALGORITHM, COMPRESSION_ALGORITHM,
 	"ENCRYPTION_ALGORITHM",
 	"PSEUDO_RANDOM_FUNCTION",
 	"INTEGRITY_ALGORITHM",
 	"DIFFIE_HELLMAN_GROUP",
-	"EXTENDED_SEQUENCE_NUMBERS");
-ENUM_END(transform_type_names, EXTENDED_SEQUENCE_NUMBERS);
+	"EXTENDED_SEQUENCE_NUMBERS",
+	"KEY_TRANSFORM_ALGORITHM");
+ENUM_END(transform_type_names, KEY_TRANSFORM_ALGORITHM);
 
 
 ENUM(extended_sequence_numbers_names, NO_EXT_SEQ_NUMBERS, EXT_SEQ_NUMBERS,
 	"NO_EXT_SEQ",
 	"EXT_SEQ",
-);
+);
\ No newline at end of file
